///////////////////////////////////////////////////////////////////////
//
// File: test.cpp
// Author: Kelvin Sung
// Date: April 2003
//
//
#include <iostream.h>

#include "windows.h"
			// for Sleep

#include "TthreadBase.h"


int main() {

	const int kNumWorkers = 5;

	int workTimes[kNumWorkers] = {6, 5, 3, 2, 1};
	TthreadBase *workThreads[kNumWorkers];
	int workerID = 0;

	cout << "Creating ThreadBases: 5 threads ..." << endl;


	for (int i=0; i<kNumWorkers; i++) {
		workThreads[i] = new TthreadBase("DumbThread", i, workTimes[i]);
		workThreads[i]->StartThread();
	}

	int id = 1;
	while (id != -1) {
		cout << "Terminate which thread? [main(-1) [0-4]? ";
		cin >> id;
		if ( (id>0) && (id<=kNumWorkers) && (workThreads[i] != NULL) ) {
			workThreads[id]->TerminateThread();
		}
	}
	cout << "Main thread sleeping 0.5 seconds  .... ";

	Sleep(500);
		// sleep 0.5 seconds (0.5*1000 milli-seconds) 

	cout << endl;
	cout << "Main thread quiting ... " << endl;

	return 0;
}

